package com.example.zxa01.iotclient.component.login;
import com.example.zxa01.iotclient.common.pojo.Setting;
import com.example.zxa01.iotclient.common.pojo.auth.User;
import com.example.zxa01.iotclient.common.singleton.Config;
import com.example.zxa01.iotclient.common.pojo.auth.LoginMessage;
import com.example.zxa01.iotclient.common.singleton.DefaultData;
import com.example.zxa01.iotclient.component.home.device.DeviceFragment;

import android.arch.lifecycle.MutableLiveData;
import android.databinding.BaseObservable;
import android.support.annotation.NonNull;

public class LoginModel extends BaseObservable {

    private MutableLiveData<Boolean> isAuthorized;

    public LoginModel() {
        isAuthorized = new MutableLiveData<>();
        isAuthorized.setValue(false);
    }

    public MutableLiveData<Boolean> isAuthorized() {
        return isAuthorized;
    }

    public void login(@NonNull LoginMessage message) {

        if (verification(message)) {
            settingConfig(message);
            isAuthorized.setValue(true);
        }

    }

    private boolean verification(@NonNull LoginMessage message) {
        return message.getAccount() != null &&
                message.getPassword() != null &&
                message.getAddress() != null;
    }

    private void settingConfig(@NonNull LoginMessage message) {
        Config.getConfig().setMessage(new LoginMessage(
                message.getAddress(),
                DefaultData.getDefaultData().gatewayPort,
                DefaultData.getDefaultData().cloudPort,
                message.getAccount(),
                null
        ));
        Config.getConfig().addSetting(new Setting().setKey(Config.USER).setValue(Config.getConfig().getMessage().getAccount()));
        Config.getConfig().addSetting(new Setting().setKey(Config.ADDRESS).setValue(Config.getConfig().getMessage().getAddress()));
        Config.getConfig().addSetting(new Setting().setKey(Config.LOGOUT).setValue(Config.LOGOUT_MESSAGE));
    }

}
